/**
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 * We offer the best and most useful modules PrestaShop and modifications for your online store.
 *
 * @category  PrestaShop Module
 * @author    knowband.com <support@knowband.com>
 * @copyright 2015 knowband
 * @license   see file: LICENSE.txt
 */

var msg_timeout = 10000; // 10 secs
var numeric_reg = /^[0-9]*$/;
var decimal_reg = /^[0-9]{1,10}(?:\.\d{1,4})?$/;
var date_reg = /^([0-9]{4})\-(0[1-9]|1[012])\-(0[1-9]|[12][0-9]|3[01])$/; //yyyy-mm-dd

var currency_format = 1;
var currency_sign = '$';
var currency_blank = 0;

var current_name = '';

$(document).ready(function(){
    $('.vss_demo_block, .vss_overlay_paid').hover(function(){
        if ($('.vss_overlay_paid').length) {
            if($('.vss_overlay_paid').is(':visible')) {
                $('.vss_demo_block').removeClass('vss_demo_block_hovered');
                $('.vss_overlay_paid').hide();
            } else {
                $('.vss_demo_block').addClass('vss_demo_block_hovered');
                $('.vss_overlay_paid').show();
            }
        }
    });
});


function submitConfiguration()
{
    var messgeObj = $('#content').find('.bootstrap').find('.alert');
    $(messgeObj).parent().remove();
    var errorMsg = '';
    var error = false;

    var days_value = $('input[name="velsof_abandoncart[delay_days]"]').val();
    if (days_value == '') {
        error = true;
        errorMsg += required_field_msg + '<br>';
    } else if (days_value != 0 && !numeric_reg.test(days_value)) {
        error = true;
        errorMsg += invalid_num_msg + '<br>';
    }

    if (!error) {
        var delay_hrs = $('input[name="velsof_abandoncart[delay_hours]"]').val();
        if (delay_hrs == '') {
            error = true;
            errorMsg += required_field_msg + '<br>';
        } else if (delay_hrs != 0 && !numeric_reg.test(delay_hrs)) {
            error = true;
            errorMsg += invalid_num_msg + '<br>';
        }
    }
    if ($("#abandoncart_enable_test").is(":checked")) {
        var pattern = /^([a-z\d!#$%&'*+\-\/=?^_`{|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+(\.[a-z\d!#$%&'*+\-\/=?^_`{|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+)*|"((([ \t]*\r\n)?[ \t]+)?([\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|\\[\x01-\x09\x0b\x0c\x0d-\x7f\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))*(([ \t]*\r\n)?[ \t]+)?")@(([a-z\d\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[a-z\d\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF][a-z\d\-._~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]*[a-z\d\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])\.)+([a-z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[a-z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF][a-z\d\-._~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]*[a-z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])\.?$/i;
        if (!error) {
            var email = $('input[name="velsof_abandoncart[testing_email_id]"]').val();
            if (email == '') {
                error = true;
                errorMsg += required_field_msg + '<br>';
            } else if (email != 0 && !pattern.test(email)) {
                error = true;
                errorMsg += email_err + '<br>';
            }
        }
    }

    if (!error) {
        $('#abandoncart_configuration_form').submit();
    } else {
        var errorHtml = '<div class="bootstrap abd-global-message"><div class="alert alert-danger">';
        errorHtml += '<button type="button" class="close" data-dismiss="alert">×</button>';
        errorHtml += errorMsg;
        errorHtml += '</div></div>';
        $('#velsof_abandoncart_container').before(errorHtml);
        setTimeout(function() {
            $('#velsof_abandoncart_container .abd-global-message').remove();
        }, msg_timeout);
    }

}

function dismiss_ac_modal(modal) {
    $('#' + modal + '_load').hide();
    $('#' + modal).modal('hide');
    $('#' + modal + '_progress').hide();
}

function resetAbandonedListFilter(page_number)
{
    $('#abd-list-filters select[name="abd_filter_type"] option').removeAttr('selected');
    $('#abd-list-filters input[name="abd_filter_type_email"]').attr('value', '');
    $('#abd-list-filters select[name="abd_filter_ctype"] option').removeAttr('selected');
    getAbandonedList(page_number);
}

function getAbandonedListonchange(a)
{
    getAbandonedList($('#abd_list_current_page').attr('value'));
}

function getAbandonedList(page)
{
    var filter_str = '';
    if ($('#abd-list-filters input[name="abd_filter_type_email"]').attr('value') != '') {
        filter_str += '&qtype=' + $('#abd-list-filters select[name="abd_filter_type"]').val();
        filter_str += '&email=' + $('#abd-list-filters input[name="abd_filter_type_email"]').val();
    }

    if ($('#abd-list-filters select[name="abd_filter_ctype"]').val() != '') {
        filter_str += '&ctype=' + $('#abd-list-filters select[name="abd_filter_ctype"]').val();
    }

    $.ajax({
        url: action,
        data: '&ajax=true&method=getabandonlist&page_number=' + page + filter_str + '&cart_per_page=' + $('select[name=carts_per_page]').val(),
        type: 'post',
        datatype: 'json',
        beforeSend: function()
        {
            $('#abd-list-block .abd-bigloader').show();
        },
        success: function(json)
        {
            $('#abd-list-block .abd-bigloader').hide();

            if (json['flag']) {
                var html = '';
                var i = 0;
                var row_class = 'odd';
                for (i = 0; i < json['data'].length; i++) {
                    if (i % 2 == 0)
                        row_class = 'even';
                    html += '<tr class="pure-table-' + row_class + '">';
                    html += '<td class="right">' + (json['start_serial'] + i) + '</td>';
                    if (typeof json['data'][i]['tracked'] != 'undefined' && json['data'][i]['tracked'] == 1)
                    {
                        if (json['data'][i]['firstname'] != 'ABC' && json['data'][i]['lastname'] != 'DEF')
                            html += '<td><span class="tbl-cl-main-txt">' + json['data'][i]['firstname'] + ' ' + json['data'][i]['lastname'] + '</span><span class="tbl-cl-sub-txt">' + json['data'][i]['email'] + '</span>';
                        else
                            html += '<td><span class="tbl-cl-main-txt">' + ac_gust_cus_label + '</span><span class="tbl-cl-sub-txt">' + json['data'][i]['email'] + '</span>';
                    }
                    else if (json['data'][i]['id_customer'] <= 0)
                        html += '<td><span class="tbl-cl-main-txt">' + ac_gust_cus_label + '</span>';
                    else
                        html += '<td><span class="tbl-cl-main-txt">' + json['data'][i]['firstname'] + ' ' + json['data'][i]['lastname'] + '</span><span class="tbl-cl-sub-txt">' + json['data'][i]['email'] + '</span>';

                    html += '<span class="tbl-cl-sub-txt" style="display: block;">Language: ' + json['data'][i]['language_text'] + '</span></td>';
                    if (json['data'][i]['is_guest'] == 1) {
                        html += '<td >' + ac_guest_txt + '</td>';
                    } else {
                        html += '<td >' + ac_registered_txt + '</td>';
                    }

                    if (!json['data'][i]['has_coupon']) {
                        if ((typeof json['data'][i]['reminder_sent'] != 'undefined') && json['data'][i]['reminder_sent'] == 1)
                            html += '<td >' + reminder_sent_txt + '</td>';
                        else
                            html += '<td >' + ac_no_coupon_txt + '</td>';
                    } else {
                        html += '<td ><a href="javascript:void(0)" onclick="displayCouponDetail(' + json['data'][i]['id_customer'] + ', \'' + json['data'][i]['email'] + '\')">' + ac_coupon_details_txt + '</a></td>';
                    }
                    html += '<td>' + json['data'][i]['date_upd'] + '</td>';
                    html += '<td class="list_action_btn">';
                    if (json['data'][i]['id_customer'] <= 0)
                    {
                        if (typeof json['data'][i]['tracked'] != 'undefined' && json['data'][i]['tracked'] == 1)
                            html += '<a href="javascript:void(0)" onclick="displayReminderModal(' + json['data'][i]['id_customer'] + ',' + json['data'][i]['id_cart'] + ',' + json['data'][i]['id_abandon'] + ',' + json['data'][i]['id_lang'] + ');" class="glyphicons bell"><i data-toggle="tooltip"  data-placement="top" data-original-title="' + ac_send_non_discount_email_txt + '"></i></a>';
                        else
                            html += '<a href="javascript:void(0)" onclick="" class="glyphicons bell disabaled_glyphicons"><i data-toggle="tooltip" style="cursor: default;" data-placement="top" data-original-title="' + ac_email_not_txt + '"></i></a>';
                    }
                    else
                        html += '<a href="javascript:void(0)" onclick="displayReminderModal(' + json['data'][i]['id_customer'] + ',' + json['data'][i]['id_cart'] + ',' + json['data'][i]['id_lang'] + ');" class="glyphicons bell"><i data-toggle="tooltip"  data-placement="top" data-original-title="' + ac_send_non_discount_email_txt + '"></i></a>';

                    if (json['data'][i]['id_customer'] <= 0)
                        html += '<a href="javascript:void(0)" onclick="" class="glyphicons gift disabaled_glyphicons"><i data-toggle="tooltip" style="cursor: default;" data-placement="top" data-original-title="' + ac_email_not_txt + '"></i></a>';
                    else
                        html += '<a href="javascript:void(0)" onclick="displayDisocuntEmailModal(' + json['data'][i]['id_customer'] + ',' + json['data'][i]['id_cart'] + ',' + json['data'][i]['id_abandon'] + ',' + json['data'][i]['id_lang'] + ');" class="glyphicons gift"><i data-toggle="tooltip"  data-placement="top" data-original-title="' + ac_send_discount_email_txt + '"></i></a>';
                    html += '<a href="javascript:void(0)" onclick="displayCartDetail(' + json['data'][i]['id_customer'] + ',' + json['data'][i]['id_cart'] + ');" class="glyphicons shopping_cart"><i data-toggle="tooltip"  data-placement="top" data-original-title="' + ac_view_products_txt + '"></i></a>';
                    html += '<a type="' + json['data'][i]['id_abandon'] + '" href="javascript:void(0)" onclick="deleteAbandon(this);" class="glyphicons remove"><i data-toggle="tooltip"  data-placement="top" data-original-title="' + ac_remove_cart_txt + '"></i></a>';
                    html += '</td>';
                    html += '</tr>';
                }
                $('#abandon_cart_list_body').html(html);
                $('#abd_list_current_page').attr('value', page);
            } else {
                var html = '<tr class="pure-table-odd empty-tbl"><td colspan="6" class="center"><span>' + empty_list_msg + '</span></td><tr>';
                $('#abandon_cart_list_body').html(html);
            }
            $('#abd-list-block .paginator-block').html(json['pagination']);
            $('[data-toggle="tooltip"]').tooltip();
        },
        error: function(XMLHttpRequest, textStatus, errorThrown) {
            $('#abd-list-block .abd-bigloader').hide();
            alert('Technical error occurred. Contact to support.');
        }
    });
}


function displayCartDetail(id_customer, id_cart)
{
    $('#cart_detail_tbl').hide();
    $('#cart_detail_loader').show();
    $('#cart_detail_modal').modal({'show': true, 'backdrop': 'static'});
    $.ajax({
        type: 'POST',
        url: action,
        data: '&ajax=true&method=getCustomerCartDetail&id_customer=' + id_customer + '&id_cart=' + id_cart,
        dataType: 'json',
        success: function(json) {
            if (json['customer']['fname'] != null && json['customer']['lname'] != null)
                $('#cart_detail_modal .ac_modal_customer_name').html(json['customer']['fname'] + ' ' + json['customer']['lname'] + ' - ');
            var html = '';
            if (json['products'].length > 0) {
                for (var i in json['products']) {
                    html += '<tr>';
                    html += '<td><a  href="' + json['products'][i]['pro_link'] + '" target="_blank"><img src="' + json['products'][i]['img_link'] + '" height="100px" width="100px"/></a></td>';
                    html += '<td style="text-align:left;"><a href="' + json['products'][i]['pro_link'] + '" target="_blank">' + json['products'][i]['name'] + '</a>' + ((json['products'][i]['attributes'] != '' && json['products'][i]['attributes'] != undefined) ? '<br><small>' + json['products'][i]['attributes'] + '</small>' : '') + '</td>';
                    html += '<td>' + ((json['products'][i]['reference'] != '') ? json['products'][i]['reference'] : '') + '</td>';
                    html += '<td>' + json['products'][i]['quantity'] + '</td>';
                    html += '<td>' + json['products'][i]['price_wt'] + '</td>';
                    html += '<td>' + json['products'][i]['total_wt'] + '</td>';
                    html += '</tr>';
                }
                html += '<tr><td class="ac_cart_total_row" colspan="5">' + ac_cart_total_msg + '</td><td class="ac_cart_total_row">' + json['cart_total'] + '</td></tr>'
            } else {
                html += '<tr><td colspan="6">' + ac_no_data_found + '</td></tr>';
            }
            $('#ac_cart_product_row').html(html);
            $('#cart_detail_loader').hide();
            $('#cart_detail_tbl').show();
        },
        error: function(XMLHttpRequest, textStatus, errorThrown) {
            alert('Technical error occurred. Contact to support.');
            removeCartDetailModal();
        }
    });
}

function removeCartDetailModal()
{
    dismiss_ac_modal('cart_detail_modal');
    $('#ac_cart_product_row').html('');
    $('#cart_detail_modal .ac_modal_customer_name').html('');
}

function deleteAbandon(elem)
{
    var id = $(elem).attr("type");
    selected_abd_rem_id = id;
    $('#modal_abandon_remove .modal-action-btn').show();
    $('#abd-rem-confrm-msg').show();
    $('#abandon_remove_processing').hide();
    $('#modal_abandon_remove').modal({'show': true, 'backdrop': 'static'});
}


function delAbandonAction(rem_action)
{
    if (rem_action == 1) {
        $('#modal_abandon_remove .modal-action-btn').hide();
        $('#abd-rem-confrm-msg').hide();
        $('#abandon_remove_processing').show();
        $.ajax({
            type: 'POST',
            url: action,
            data: '&ajax=true&method=deleteabandon&id_abandon=' + selected_abd_rem_id,
            dataType: 'json',
            success: function(json) {
                var msg_class = '';
                if (json['status']) {
                    msg_class = 'alert-success';
                    getAbandonedList($('#abd_list_current_page').attr('value'));
                } else {
                    msg_class = 'alert-danger';
                }
                $('#tab_abandon_list_msg_bar').removeClass('alert-success');
                $('#tab_abandon_list_msg_bar').removeClass('alert-danger');
                $('#tab_abandon_list_msg_bar').addClass(msg_class);
                $('#tab_abandon_list_msg_bar').html(json['message']);
                $('#tab_abandon_list_msg_bar').show();
                setTimeout(function() {
                    $('#tab_abandon_list_msg_bar').hide();
                    $('#tab_abandon_list_msg_bar').html('');
                }, msg_timeout);
                delAbandonAction(0);
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                alert('Technical error occurred. Contact to support.');
                delAbandonAction(0);
            }
        });
    } else {
        selected_abd_rem_id = 0;
        $('#modal_abandon_remove .modal-action-btn').show();
        $('#abd-rem-confrm-msg').show();
        $('#abandon_remove_processing').hide();
        $('#modal_abandon_remove').modal('hide');
    }
}

function cart_preview(a)
{
    $("#vss_cart_image").attr('src', image_path + "cart_image_" + $(a).val() + ".png")
    $("#vss_cart_image_template").attr('src', image_path + "cart_image_" + $(a).val() + ".png")
}

function showLiteAlert()
{
    $('#modal_abandon_lite_version .modal-action-btn').show();
    $('#abd-lite-msg').show();
    $('#modal_abandon_lite_version').modal({'show':true, 'backdrop':'static'});
}

function showLiteAlertAction()
{
    $('#modal_abandon_lite_version .modal-action-btn').show();
    $('#abd-lite-msg').show();
    $('#modal_abandon_lite_version').modal('hide');
}